package com.shiny.keyboard.recycler;


import android.content.Context;
import android.content.Intent;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;

import androidx.annotation.NonNull;
import androidx.recyclerview.widget.RecyclerView;

import com.bumptech.glide.Glide;
import com.shiny.keyboard.R;
import com.shiny.keyboard.bean.ChildData;
import com.shiny.keyboard.databinding.ListChildBinding;
import com.shiny.keyboard.helper.Utils;
import com.shiny.keyboard.mylistener.OnItemClickListener;
import com.shiny.keyboard.ui.SetThemeActivity;

import java.util.ArrayList;
import java.util.List;

public class AdapterChild extends RecyclerView.Adapter<AdapterChild.ChildViewHolder> {

    private Context mContext;
    private List<ChildData> mList = new ArrayList<>();

    private OnItemClickListener mCallBack;


    public AdapterChild(Context context, List<ChildData> list) {
        mContext = context;
        this.mList = list;
    }


    public void setClickAction(OnItemClickListener callback) {
        mCallBack = callback;
    }

    @NonNull
    @Override
    public ChildViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
        ListChildBinding inflate = ListChildBinding.inflate(LayoutInflater.from(parent.getContext()));


        return new ChildViewHolder(inflate);
    }

    @Override
    public void onBindViewHolder(@NonNull ChildViewHolder holder, int position) {
        ChildData childData = mList.get(position);


        String thumbGif = childData.getThumbGif();
        String thumb = childData.getThumbUrl();
        if (!thumbGif.isEmpty()) {
            Utils.INSTANCE.loadWepJif(mContext, thumbGif, holder.binding.imageView);
        } else {
            Glide.with(mContext).load(thumb)
                    .placeholder(R.drawable.img_placeholder)
                    .into(holder.binding.imageView);
        }

        holder.binding.fragme.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Intent intentApply = new Intent(mContext, SetThemeActivity.class);
                intentApply.putExtra(SetThemeActivity.SOURCE_KEY, childData);
//                intentApply.putExtra(SetThemeActivity.DISPLAY_URL_KEY, childData.getImgPath());
//                intentApply.putExtra(SetThemeActivity.ZIP_URL_KEY, childData.getZipPath());
//                intentApply.putExtra(SetThemeActivity.NAME_KEY, childData.getTitleName());
//                intentApply.putExtra(SetThemeActivity.GIF_KEY, childData.getImgGif());
                String intent_thumb;
                if (!thumbGif.isEmpty()) {
                    intent_thumb = thumbGif;
                } else {
                    intent_thumb = thumb;
                }
//                intentApply.putExtra(SetThemeActivity.THUMB_KEY, intent_thumb);
                mContext.startActivity(intentApply);
                if (mCallBack != null) {
                    mCallBack.onItemClick();
                }

            }
        });


    }

    @Override
    public int getItemCount() {
        return mList.size();
    }

    public static class ChildViewHolder extends RecyclerView.ViewHolder {

        private ListChildBinding binding;


        public ChildViewHolder(@NonNull ListChildBinding itemView) {
            super(itemView.getRoot());
            binding = itemView;


        }

    }

//    private void loadWepJif(String webpGifUrl,ImageView view){
//        Glide.with(mContext).load(webpGifUrl).addListener(new RequestListener<Drawable>() {
//            @Override
//            public boolean onLoadFailed(@Nullable GlideException e, @Nullable Object model, @NonNull Target<Drawable> target, boolean isFirstResource) {
//                return false;
//            }
//
//            @Override
//            public boolean onResourceReady(@NonNull Drawable resource, @NonNull Object model, Target<Drawable> target, @NonNull DataSource dataSource, boolean isFirstResource) {
//               if(resource instanceof WebpDrawable){
//                   WebpDrawable webpDrawable = (WebpDrawable) resource;
//                   webpDrawable.setLoopCount(LOOP_FOREVER);
//               }
//
//                return false;
//            }
//        }).into(view);
//    }
}
